#pragma once
// as_scripting.
// Written by Dominque Douglas
// Copyright 2013 Dominque Douglas


// Include the definitions of the script library and the add-ons we'll use.
// The project settings may need to be configured to let the compiler where
// to find these headers. Don't forget to add the source modules for the
// add-ons to your project as well so that they will be compiled into the 
// application.
#include <angelscript.h>
#include "scriptbuilder/scriptbuilder.h"

//#include "game.h"

// enumerations -------------------------------------------------------------
enum ScriptFunctionIDs
{
	Function_InitApp = 0
};

const unsigned int max_script_functions = 1;

// Structures ---------------------------------------------------------------
struct ScriptContextData
{
	asIScriptContext *ctx;
	asIScriptFunction *script_functions[max_script_functions];

	void ExecuteFunction(ScriptFunctionIDs func_id);
};

// Forward Declarations -----------------------------------------------------
int StartScriptingSystem(asIScriptEngine *&scriptengine, CScriptBuilder &scriptbuilder, ScriptContextData &contextdata);
void ShutdownScriptingSystem(asIScriptEngine *&scriptengine, asIScriptContext *&ctx);

int RegisterGameInterface(asIScriptEngine *scriptengine);
int RegisterEnumGAME_MODE(asIScriptEngine *scriptengine);

int LoadScript(asIScriptEngine *scriptengine, CScriptBuilder &scriptbuilder, ScriptContextData &contextdata);