// scriptd3dxcolor.cpp
// Written by Dominque Douglas
// Copyright 2013 Dominque Douglas
#include "DXUT.h"
#include "scriptdroidammostates.h"

int RegisterDROID_STATE(asIScriptEngine *scriptengine)
{
	int r;

	// register AI_STATE enum
	r = scriptengine->RegisterEnum("AI_STATE");
	if(r < 0) return r;

	r = scriptengine->RegisterEnumValue("AI_STATE", "AI_TURNING", (int)AI_TURNING);
	if(r < 0) return r;

    r = scriptengine->RegisterEnumValue("AI_STATE", "AI_MOVING", (int)AI_MOVING);
	if(r < 0) return r;

    r = scriptengine->RegisterEnumValue("AI_STATE", "AI_STOPPED", (int)AI_STOPPED);
	if(r < 0) return r;

	// Register DROID_STATE as POD Value type
	// Register a primitive type, that doesn't need any special management of the content
	r = scriptengine->RegisterObjectType("DROID_STATE", sizeof(DROID_STATE), asOBJ_VALUE | asOBJ_APP_CLASS | asOBJ_POD);
	if(r < 0) return r;

    r = scriptengine->RegisterObjectProperty("DROID_STATE", "bool bActive", asOFFSET(DROID_STATE,bActive));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXVECTOR3 vPosition", asOFFSET(DROID_STATE,vPosition));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXVECTOR3 vVelocity", asOFFSET(DROID_STATE,vVelocity));
	if(r < 0) return r;
	r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXVECTOR3 vNudgeVelocity", asOFFSET(DROID_STATE,vNudgeVelocity));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "AI_STATE aiState", asOFFSET(DROID_STATE,aiState));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "float fTargetRotation", asOFFSET(DROID_STATE,fTargetRotation));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXQUATERNION qTarget", asOFFSET(DROID_STATE,qTarget));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXQUATERNION qStart", asOFFSET(DROID_STATE,qStart));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXQUATERNION qCurrent", asOFFSET(DROID_STATE,qCurrent));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "float fRotInterp", asOFFSET(DROID_STATE,fRotInterp));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "float fTaskTimer", asOFFSET(DROID_STATE,fTaskTimer));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "int nHitPoints", asOFFSET(DROID_STATE,nHitPoints));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "float fDeathAnimation", asOFFSET(DROID_STATE,fDeathAnimation));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "float fAlpha", asOFFSET(DROID_STATE,fAlpha));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("DROID_STATE", "D3DXCOLOR Specular", asOFFSET(DROID_STATE,Specular));

	return r;
}

int RegisterAMMO_STATE(asIScriptEngine *scriptengine)
{
	int r;

	// Register AMMO_STATE as POD Value type
	// Register a primitive type, that doesn't need any special management of the content
	r = scriptengine->RegisterObjectType("AMMO_STATE", sizeof(AMMO_STATE), asOBJ_VALUE | asOBJ_APP_CLASS | asOBJ_POD);
	if(r < 0) return r;

    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "bool bActive", asOFFSET(AMMO_STATE,bActive));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "D3DXVECTOR3 vPosition", asOFFSET(AMMO_STATE,vPosition));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "D3DXVECTOR3 vVelocity", asOFFSET(AMMO_STATE,vVelocity));
	if(r < 0) return r;
	r = scriptengine->RegisterObjectProperty("AMMO_STATE", "D3DXVECTOR4 Diffuse", asOFFSET(AMMO_STATE,Diffuse));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "double fTimeCreated", asOFFSET(AMMO_STATE,fTimeCreated));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "float fLifeCountdown", asOFFSET(AMMO_STATE,fLifeCountdown));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "float fAlpha", asOFFSET(AMMO_STATE,fAlpha));
	if(r < 0) return r;
    r = scriptengine->RegisterObjectProperty("AMMO_STATE", "bool bGround", asOFFSET(AMMO_STATE,bGround));
	if(r < 0) return r;

	// don't provide direct access to D3DXMATRIXA16 mAmmoRot. Instead, just provide a function to create get a random rotation
	r = scriptengine->RegisterObjectMethod("AMMO_STATE", "void SetRandomRotation()", asMETHOD(AMMO_STATE, SetRandomRotation), asCALL_THISCALL);

	return r;
}